# Pantera Passive Plugin - Check if page has permament cookie
#
# FILENAME      : check_for_permamentcookie.py
# CODER         : Simon Roses Femerling
# DATE          : 07/25/2006
# LAST UPDATE   : 
# ABSTRACT      : Check if page has permament cookie
#       
# - Roses Labs Innovations (RL+I)
# Roses Labs
# http://www.roseslabs.com
#
# Copyright (c) 2003-2006 Roses Labs.
#
# You may not distribute, transmit, repost this software for commercial 
# purposes without Roses Labs written permission. 
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, publish,
# distribute the Software, and to permit persons to whom the Software 
# is furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included
# in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
# IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
# TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
# SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
#

'''
@author:       Simon Roses Femerling
@license:      GNU General Public License 2.0 or later
@contact:      pantera.proxy@gmail.com
@organization: OWASP / Roses Labs
'''

from panteraPlugins import PPM
import re

plugin_info =  {'id':"CheckForPermamentCookies",
                'name':"Permamanet Cookies Check",
                'author':"Simon Roses Femerling",
                'email':"sroses@roseslabs.com",
                'version':"0.1",
                'desc':"Check if page has permament cookie",
                'tag':"cookie"  # defined tags else ignore plugin
                } 

class CheckForPermamentCookies(PPM):
    '''
    CheckForPermanentCookies class.
    '''
    
    def InitAnalyzer(self):
        '''
        Init function.
        '''
        PPM.__init__(self)
        self.expire = re.compile('Expires',re.IGNORECASE)
        self.cont = False

    def BeginAnalyzer(self,obj):
        '''
        Begin function.
        '''
        self.SetObjData(obj)
        for h in obj.serverheader.headerValuesDict.keys():
            t = h.lower()
            if t == 'set-cookie' or t == 'set-cookie2':
                co = obj.serverheader.headerValuesDict[h]
                for c in co:
                    res = self.expire.search(c)
                    if res:
                        self.cont = True
                if self.cont == False:
                    self.SetResult(1,'vuln')
                    self.SetLevel('low')
                    s = "Page has cookies but do not expire."
                    self.SetResultData(s)
                
# RL+I EOF